<template>
  <input
    :id="id"
    :checked="modelValue"
    type="checkbox"
    tabindex="-1"
    class="flex h-6 w-5 cursor-pointer appearance-none items-center justify-center outline-none before:relative before:left-0.25 before:h-0.5 before:origin-right before:rounded before:bg-slate-400 before:transition-all before:content-[''] after:relative after:h-3 after:w-3 after:origin-left after:rounded-full after:border-2 after:border-slate-300 after:bg-transparent after:transition-all after:content-[''] checked:before:w-2/5 checked:before:translate-y-1 checked:before:rotate-45 checked:after:h-0.5 checked:after:w-4/6 checked:after:translate-y-1 checked:after:-rotate-45 checked:after:rounded checked:after:border-0 checked:after:bg-slate-400 hover:scale-110 hover:before:bg-fuchsia-500 hover:after:bg-fuchsia-500 active:scale-90"
    @change="updateModelValue"
  />
</template>

<script lang="ts" setup>
defineProps<{
  id: string;
  modelValue: boolean;
}>();
const emit = defineEmits<{
  (e: 'update:modelValue', id: boolean): void;
}>();
const updateModelValue = (e: Event) => {
  e.preventDefault();
  const { checked } = e.target as HTMLInputElement;
  emit('update:modelValue', checked);
};
</script>
